<?php
/**
 * Copyright © 2018 Filoblu S.r.l. All rights reserved.
 */

namespace FiloBlu\Flow\Block\Adminhtml\System\Config;

use Magento\Backend\Block\Template\Context;
use Magento\Config\Block\System\Config\Form\Field\FieldArray\AbstractFieldArray;
use Magento\Framework\Exception\LocalizedException;
use Magento\Payment\Api\PaymentMethodListInterface;
use Magento\Sales\Model\ResourceModel\Order\Status\Collection;
use Magento\Sales\Model\ResourceModel\Order\Status\CollectionFactory;

/**
 * Renderer for Event Configuration
 */

class Specialactions extends AbstractFieldArray
{

    /**
     * @var Collection
     */
    protected $collection;

    /**
     * Statuses per state array
     *
     * @var array
     */
    protected $stateStatuses;

    /**
     * @var Status
     */
    protected $orderStatusFactory;

    /**
     * @var CollectionFactory
     */
    protected $orderStatusCollectionFactory;

    /**
     * @var PaymentMethodListInterface
     */
    protected $methodList;

    /**
     * @var Payment Methods
     */
    protected $paymentMethodRenderer = null;

    /**
     * Specialactions constructor.
     * @param Context $context
     * @param array $data
     */
    public function __construct(
        Context $context,
        array $data = []
    ) {
        parent::__construct($context, $data);
    }

    /**
     * Enable the "Add after" button or not
     *
     * @var bool
     */
    protected $_addAfter = true;

    /**
     * @throws LocalizedException
     */
    protected function _prepareToRender()
    {
        $this->addColumn('name', [
            'label' => __('Name')
        ]);

        $eventTypeBlock=$this->getLayout()->createBlock('Magento\Framework\View\Element\Html\Select')
                        ->setId($this->_getCellInputElementId('<%- _id %>', 'executed_on'))
                        ->setName($this->_getCellInputElementName('executed_on'))
                        ->setClass('select')
                        ->setOptions(
                            [
                                ['value' => '', 'label' => __('-- Please Select --')],
                                ['value' => 'product', 'label' => __('Product')],
                                ['value' => 'attribute', 'label' => __('Attribute')]
                            ]
                        );

        $this->addColumn('executed_on', [
            'label' => __('Executed On'),
            'renderer' => $eventTypeBlock
        ]);

        $this->addColumn('priority', [
            'label' => __('Priority')
        ]);

        $this->_addAfter = false;
        $this->_addButtonLabel = __('Add new special action config');
    }
}
